<template>
  <a-modal
    :title="title"
    :width="800"
    :visible="visible"
    :confirmLoading="confirmLoading"
    @ok="handleOk"
    @cancel="handleCancel"
    cancelText="关闭"
    wrapClassName="ant-modal-cust-warp"
    style="top: 5%; height: 85%; overflow-y: hidden"
  >
    <a-spin :spinning="confirmLoading">
      <a-form-model ref="form" v-bind="layout" :model="model" :rules="validatorRules" :hideRequiredMark="true">
        <a-form-model-item label="角色编码" required prop="roleCode" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-input v-model="model.roleCode" :disabled="roleDisabled" placeholder="请输入角色编码" />
        </a-form-model-item>

        <a-form-model-item label="角色名称" required prop="roleName" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-input v-model="model.roleName" placeholder="请输入角色名称" />
        </a-form-model-item>
        <a-form-model-item label="角色权限" prop="permissions" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <j-multi-select-tag v-model="model.permissions" dictCode="sys_role,role_name,id" placeholder="请选择角色权限">
          </j-multi-select-tag>
        </a-form-model-item>
        <a-form-model-item label="是否必须" prop="isMust" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-radio-group v-model="model.isMust">
            <a-radio :value="0">否</a-radio>
            <a-radio :value="1">是</a-radio>
          </a-radio-group>
        </a-form-model-item>
        <a-form-model-item label="描述" prop="description" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-textarea :rows="5" v-model="model.description" placeholder="请输入角色描述" />
        </a-form-model-item>
      </a-form-model>
    </a-spin>
  </a-modal>
</template>

<script>
import { addRole, editRole, duplicateCheck } from '@/api/api'
export default {
  name: 'RoleModal',
  data() {
    return {
      title: '操作',
      visible: false,
      roleDisabled: false,
      model: {},
      labelCol: {
        xs: { span: 24 },
        sm: { span: 5 },
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 16 },
      },
      layout: {
        labelCol: { span: 3 },
        wrapperCol: { span: 14 },
      },
      confirmLoading: false,
      validatorRules: {
        roleName: [
          { required: true, message: '请输入角色名称!' },
          { min: 2, max: 30, message: '长度在 2 到 30 个字符', trigger: 'blur' },
        ],
        roleCode: [
          { required: true, message: '请输入角色名称!' },
          { min: 0, max: 64, message: '长度不超过 64 个字符', trigger: 'blur' },
          { validator: this.validateRoleCode },
        ],
        description: [{ min: 0, max: 126, message: '长度不超过 126 个字符', trigger: 'blur' }],
      },
    }
  },
  created() {
    //备份model原始值
    this.modelDefault = JSON.parse(JSON.stringify(this.model))
  },
  methods: {
    add() {
      this.edit(this.modelDefault)
    },
    edit(record) {
      this.model = Object.assign({}, record)
      this.visible = true
      //编辑页面禁止修改角色编码
      if (this.model.id) {
        this.roleDisabled = true
      } else {
        this.roleDisabled = false
      }
    },
    close() {
      this.$refs.form.clearValidate()
      this.$emit('close')
      this.visible = false
    },
    handleOk() {
      const that = this
      // 触发表单验证
      this.$refs.form.validate((valid) => {
        if (valid) {
          that.confirmLoading = true
          let obj
          if (!this.model.id) {
            obj = addRole(this.model)
          } else {
            obj = editRole(this.model)
          }
          obj
            .then((res) => {
              if (res.success) {
                that.$message.success(res.message)
                that.$emit('ok')
              } else {
                that.$message.warning(res.message)
              }
            })
            .finally(() => {
              that.confirmLoading = false
              that.close()
            })
        } else {
          return false
        }
      })
    },
    handleCancel() {
      this.close()
    },
    validateRoleCode(rule, value, callback) {
      if (/[\u4E00-\u9FA5]/g.test(value)) {
        callback('角色编码不可输入汉字!')
      } else {
        let params = {
          tableName: 'sys_role',
          fieldName: 'role_code',
          fieldVal: value,
          dataId: this.model.id,
        }
        duplicateCheck(params).then((res) => {
          if (res.success) {
            callback()
          } else {
            callback(res.message)
          }
        })
      }
    },
  },
}
</script>

<style lang="less" scoped>
/deep/.ant-tabs-nav .ant-tabs-tab-active {
  
}
/deep/.ant-tabs-ink-bar {
  
}
/deep/.action-button .ant-btn-primary {
  
  
  border-radius: 2px;
}
/deep/ .ant-modal-footer {
  padding: 10px 16px 45px;
  border-top: 0;
  > div {
    display: flex;
    justify-content: center;
  }
  .ant-btn {
    width: 76px;
    height: 35px;
    line-height: 34px;
    border-radius: 2px 2px 2px 2px;
    opacity: 1;
    
    padding: 0;

 
  }

  .ant-btn-primary {
    
    
    color: #ffffff;

    &:hover {
      color: #fff !important;
    }
  }
}

// 输入框
/deep/.ant-input {
  height: 38px;
}
/deep/ textarea.ant-input {
  height: auto;
}
/deep/.input-table .tbody .td input {
  height: 38px;
}
// 下拉框
::v-deep.ant-select {
  .ant-select-selection--single {
    height: 38px;
  }
  .ant-select-selection__rendered {
    line-height: 38px;
  }
  .ant-select-dropdown-menu-item-active:not(.ant-select-dropdown-menu-item-disabled) {
    
  }
}
/deep/.ant-input-number {
  height: 38px;
  line-height: 38px;
}
/deep/.ant-select-dropdown.ant-select-dropdown--multiple
  .ant-select-dropdown-menu-item-selected
  .ant-select-selected-icon {
  
}
::v-deep.ant-form {
  & > .ant-row:nth-child(1),
  & > .ant-row:nth-child(2) {
    .ant-form-item-control-wrapper {
      position: relative;

      &::before {
        position: absolute;
        content: '*';
        color: #f10f0f;
        top: 0;
        right: -24px;
        font-size: 24px;
        line-height: 44px;
      }
    }
  }
}
</style>

<style scoped>
.aColUn > div >>> .ant-col:first-child {
  width: 10.4%;
}

.aColUn > div >>> .ant-col:nth-child(2) {
  width: 89.6%;
}

.aColUn > div >>> .ant-col:nth-child(2) > .ant-form-item-control {
  width: 93%;
}
</style>